/*
 *Wiggle Circle Animator v0.1
 *Peter Barnum <pbarnum@cs.cmu.edu>
 *
 *Copyright (c) 2010, Peter Barnum
 *
 *Distributed under the MIT license:
 *
 *Permission is hereby granted, free of charge, to any person obtaining a copy
 *of this software and associated documentation files (the "Software"), to deal
 *in the Software without restriction, including without limitation the rights
 *to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *copies of the Software, and to permit persons to whom the Software is
 *furnished to do so, subject to the following conditions:
 *
 *The above copyright notice and this permission notice shall be included in
 *all copies or substantial portions of the Software.
 *
 *THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 *THE SOFTWARE.
 */

/**
 * A simple structure to hold horizontal or vertical wiggling (frequency)
 * parameters.
 *
 * @author Peter Barnum
 * @version 0.1
 * @since 0.1
 */
public class FrequencyParameters {
    public int spatialFreq, amplitude, temporalFreq, phaseOffset;
    public boolean spatialFreqChecked, amplitudeChecked, temporalFreqChecked, phaseOffsetChecked;

    public FrequencyParameters(FrequencyParameters copy){
        this.amplitude = copy.amplitude;
        this.phaseOffset = copy.phaseOffset;
        this.spatialFreq = copy.spatialFreq;
        this.temporalFreq = copy.temporalFreq;
        this.spatialFreqChecked = copy.spatialFreqChecked;
        this.amplitudeChecked = copy.amplitudeChecked;
        this.temporalFreqChecked = copy.temporalFreqChecked;
        this.phaseOffsetChecked = copy.phaseOffsetChecked;
    }

    public FrequencyParameters(){
        this(250, 30, 5, 0, true, true, true, true);
    }

    public FrequencyParameters(int spatialFreq, int amplitude, int temporalFreq, int phaseOffset,
                               boolean spatialFreqChecked, boolean amplitudeChecked, boolean temporalFreqChecked, boolean phaseOffsetChecked){
        this.spatialFreq = spatialFreq;
        this.amplitude = amplitude;
        this.temporalFreq = temporalFreq;
        this.phaseOffset = phaseOffset;
        this.spatialFreqChecked = spatialFreqChecked;
        this.amplitudeChecked = amplitudeChecked;
        this.temporalFreqChecked = temporalFreqChecked;
        this.phaseOffsetChecked = phaseOffsetChecked;
    }
}
