/*
 *Wiggle Circle Animator v0.1
 *Peter Barnum <pbarnum@cs.cmu.edu>
 *
 *Copyright (c) 2010, Peter Barnum
 *
 *Distributed under the MIT license:
 *
 *Permission is hereby granted, free of charge, to any person obtaining a copy
 *of this software and associated documentation files (the "Software"), to deal
 *in the Software without restriction, including without limitation the rights
 *to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *copies of the Software, and to permit persons to whom the Software is
 *furnished to do so, subject to the following conditions:
 *
 *The above copyright notice and this permission notice shall be included in
 *all copies or substantial portions of the Software.
 *
 *THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 *THE SOFTWARE.
 */

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;

/**
 * Simple class to display help text in a JFrame window.
 * Includes code from http://www.kodejava.org/examples/28.html
 *
 * @author Peter Barnum
 * @version 0.1
 * @since 0.1
 */
public class HelpDialog extends javax.swing.JFrame {
    WiggleCircleAnimator parent;

    /** Creates new form HelpDialog */
    public HelpDialog(WiggleCircleAnimator parent) {
        this.parent = parent;
        initComponents();
        this.setVisible(true);
        parent.stopDrawingUpdater();
    }

    private void loadTextFile(String filename){
        /*ClassLoader cldr = this.getClass().getClassLoader();

        //java.net.URL helpTextURL  = cldr.getResource("helpText.txt");
        //System.err.println("helpTextURL " + helpTextURL);

        //InputStream in = this.getClass().getResourceAsStream("/helpText.txt");

        InputStream stream = this.getClass().getResourceAsStream("/helpText.txt");
        System.err.println(stream != null);
        stream = this.getClass().getClassLoader().getResourceAsStream("helpText.txt");
        System.err.println(stream != null);
*/

        //ImageIcon aceOfDiamonds = new ImageIcon(imageURL);
/*
        File file = new File(filename);
        StringBuffer contents = new StringBuffer();
        BufferedReader reader = null;

        try{
            reader = new BufferedReader(new FileReader(file));
            String text = null;

            // repeat until all lines is read
            while ((text = reader.readLine()) != null){
                contents.append(text).append(System.getProperty("line.separator"));
            }
        } catch (FileNotFoundException e){
            e.printStackTrace();
        } catch (IOException e){
            e.printStackTrace();
        } finally{
            try{
                if (reader != null){
                    reader.close();
                }
            } catch (IOException e){
                e.printStackTrace();
            }
        }

        // show file contents here
        System.out.println(contents.toString());
*/
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea_help = new javax.swing.JTextArea();
        jButton_done = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jTextArea_help.setColumns(20);
        jTextArea_help.setEditable(false);
        jTextArea_help.setFont(new java.awt.Font("Monospaced", 0, 14));
        jTextArea_help.setLineWrap(true);
        jTextArea_help.setRows(5);
        jTextArea_help.setText("Wiggle Circle Animator v0.1\n\nCreate amazing animations with wiggly groups of circles. The only limit is your imagination! (And your artistic ability, but let's ignore that for now).\n\n1. Draw circles by left clicking, delete by right clicking.\n2. For each group of circles, you can change how much and how fast they wiggle horizontally and vertically.\n3. Because they wiggle, it's hard to know where you're drawing circles, so try pressing the pause button for more accuracy.\n\nAll of the controls have tooltip help, so just hover the mouse over them for specifics. \n\n\n\n(c) 2010 by Peter Barnum, and distributed under the MIT license.");
        jTextArea_help.setWrapStyleWord(true);
        jScrollPane1.setViewportView(jTextArea_help);

        jButton_done.setText("Done");
        jButton_done.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_doneActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(264, 264, 264)
                        .addComponent(jButton_done, javax.swing.GroupLayout.PREFERRED_SIZE, 124, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 636, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 351, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(jButton_done)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        parent.startDrawingUpdater();

    }//GEN-LAST:event_formWindowClosed

    private void jButton_doneActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_doneActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_jButton_doneActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton_done;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea_help;
    // End of variables declaration//GEN-END:variables

}
